import os.path
from Timer import Timer
from mx.DateTime import DateTime,DateTimeDelta
from GLAcontext import *
from GLAdate import *
from GLAtypes import *
from HTMLgen import *
from GLApickle import *
import ipreversal
import pprint


def histNumIP(context,ipDB,startDate,endDate):
    ips = Hist()
    ip2s = Hist()
    ip2dict = {}
    ip3dict = {}
    ip3s = Hist()
    for day in dayGenerator(startDate,endDate):
        validHitsFilename = context.makeGLAfilename(day,3,"hits")
        if os.path.isfile(validHitsFilename):
            set = unPickleFile(validHitsFilename,context)
            for entry in set:
                entryDomain = translateIP(entry.ipadres,ipDB)
                if alldigits(entryDomain):
                    ips.add(entryDomain)
                    ip1,ip2,ip3,ip4 = entryDomain.split(".")
                    ip3pre = ip1+"."+ip2+"."+ip3
                    ip3s.add(ip3pre)
                    ip3dict.setdefault(ip3pre,Hist())
                    ip3dict[ip3pre].add(entryDomain)
                    ip2pre = ip1+"."+ip2
                    ip2s.add(ip2pre)
##                    ip2dict.setdefault(ip2pre,[])
##                    if not entryDomain in ip2dict[ip2pre]:
##                        ip2dict[ip2pre].append(entryDomain)
                    ip2dict.setdefault(ip2pre,Hist())
                    ip2dict[ip2pre].add(entryDomain)
    for val,ip in ip2s.getHist():
        if val>50:
            print "%15s"%ip,"\t%3d"%val,"\t",ip2dict[ip].getNrEntries(),
            print ip2dict[ip].getHist()[-1]
    for val,ip in ip3s.getHist():
        if val>15:
            print "%15s"%ip,"\t%3d"%val,"\t",ip3dict[ip].getNrEntries(),
            print ip3dict[ip].getHist()[-1]


def main():
    t = Timer()
    drive = os.path.splitdrive(os.getcwd())[0]
    root = os.path.join(drive,"/gaudi")
    context = Context(root,LogFile(os.path.join(root,"temp\\GLA"),
                                   toWindow=1,showInfo=0))
    ipDB = ipreversal.IPdb(os.path.join(context.PythonTools,"ipreverseNew.txt"))
    startDate, endDate = context.getDateRange()
    print t.stamp("initialized")
    histNumIP(context,ipDB,startDate,endDate)
    print t.stamp("finished")
    context.close()
    
if __name__ == '__main__':
    main()
