import os
import os.path
import string
import sys
from mx.DateTime import DateTime,DateTimeDelta
import socket

monthNr = {"Jan":1,"Feb":2,"Mar":3,"Apr":4,
         "May":5,"Jun":6,"Jul":7,"Aug":8,
         "Sep":9,"Oct":10,"Nov":11,"Dec":12}

class entry:
    def __init__(self, entryLine):
##        print entryLine
        self.domain =entryLine[0]
        self.ipadres = self.domain
        try:
            d,mon,y = entryLine[3][1:12].split("/")
            h,m,s = string.split(entryLine[3][13:],":")
        except ValueError:
            print "ValueError in line: "
            print entryLine
            sys.exit(0)
        self.datetime = DateTime(int(y),monthNr[mon],int(d),
                                             int(h),int(m),int(s))
        self.command = entryLine[5]
        self.dir,file = os.path.split(entryLine[6])
        self.file,self.ext = os.path.splitext(file)
        self.ext = self.ext[1:]
        self.protocol = entryLine[7]
        self.status = [entryLine[-2]]
        length = entryLine[-1]
        if length.isdigit():
            self.length = int(length)
        else:
            self.length = 0
    def str(self):
        return self.domain+" "+ self.datetime.strftime("%Y-%m-%d:%H:%M:%S")+" "+\
               self.command+" "+\
               self.dir+ self.file+ "."+self.ext+" "+\
               self.protocol+" "+\
               str(self.status)+ " "+\
               str(self.length)
    def sizeofContents(self):
        return sizeof(self.status)+sizeof(self.protocol)+\
               sizeof(self.file)+sizeof(self.ext)+sizeof(self.dir)+\
               sizeof(self.command)+sizeof(self.datetime)+\
               sizeof(self.ipadres)+\
               sizeof(self.domain)

class ESIentry:
    def __init__(self, entryLine, IPdict):
##        print entryLine
##        print entryLine[0].split("-"), entryLine[1].split(":")
        
        self.ipadres = entryLine[2]
        if self.ipadres in IPdict:
            self.domain = IPdict[self.ipadres]
        else:
            try:
                self.domain = socket.gethostbyaddr(self.ipadres)[0]
                IPdict[self.ipadres] = self.domain
            except socket.herror:
                self.domain = self.ipadres
                IPdict[self.ipadres] = self.ipadres
        try:
            y,mon,d = entryLine[0].split("-")
            h,m,s = entryLine[1].split(":")
        except ValueError:
            print "ValueError in line: "
            print entryLine
            sys.exit(0)
        self.datetime = DateTime(int(y),int(mon),int(d),
                                             int(h),int(m),int(s))
        self.command = entryLine[6]
        self.dir,file = os.path.split(entryLine[7])
        self.file,self.ext = os.path.splitext(file)
        self.ext = self.ext[1:]
##        self.protocol = entryLine[7]
        self.status = [entryLine[9]]
        if len(entryLine)>11:
            self.referer = entryLine[11]
        else: self.referer = ""
        length = entryLine[10]
        if length.isdigit():
            self.length = int(length)
        else:
            self.length = 0
    def str(self):
        return self.domain+" "+ self.datetime.strftime("%Y-%m-%d:%H:%M:%S")+" "+\
               self.command+" "+\
               self.dir+ self.file+ "."+self.ext+" "+\
               str(self.status)+ " "+\
               str(self.length)
    def sizeofContents(self):
        return sizeof(self.status)+sizeof(self.protocol)+\
               sizeof(self.file)+sizeof(self.ext)+sizeof(self.dir)+\
               sizeof(self.command)+sizeof(self.datetime)+\
               sizeof(self.ipadres)+\
               sizeof(self.domain)
    
