import os.path
from GLAcontext import *
from GLAdate import *
from GLApickle import *

from reportlab.graphics.shapes import *
from reportlab.graphics.charts.linecharts import HorizontalLineChart
from reportlab.graphics import renderPM

books = [
    "SystemArchitecture",
    "ArchitecturalReasoning",
    "ComposableArchitectures",
    "SupportingProcesses",
    "HumanMeasure",
    "Thesis"]
def makeOverviewGraph(startDate,endDate,context,analyzerData):
    drawing = Drawing(800, 500)
    data = [[],[],[],[],[],[]]
    cum = [0,0,0,0,0,0]
    catNames = []
    for aDate in monthGenerator(startDate,endDate):
        catNames.append( str(aDate.year)+"\n"+str(aDate.month))
##        if os.path.isfile(context.makeGLAfilename(aDate, 2, "IPhist")):
##            IPhist = unPickleFile(context.makeGLAfilename(aDate, 2, "IPhist"))
##            counters = unPickleFile(context.makeGLAfilename(aDate, 2, "counters"))
##            data[0].append(counters.get("size")/counters.get("days")/1000000)
        stat,counters = unPickleFile(context.makeGLAfilename(aDate, 2, "stat"),context)
        stats = stat["pdf.ROW"]
        nrdays = counters.get("days")
        for index in range(len(books)):
            cum[index]=float(stats.hist.setdefault((books[index]+"Book","pdf"),0))/nrdays
            data[index].append(cum[index])
    print catNames
    lc = HorizontalLineChart()
    lc.x = 50
    lc.y = 50
    lc.height = 325
    lc.width = 700
    lc.data = data
    lc.joinedLines = 1
##    catNames = string.split(
##        'May Jun Jul Aug Sep Oct Nov Dec Jan Feb Mar Apr May Jun Jul Aug Sep', ' ')
    lc.categoryAxis.categoryNames = catNames
    lc.categoryAxis.labels.boxAnchor = 'n'
    lc.valueAxis.valueMin = 0
    lc.valueAxis.valueMax = 13
    lc.valueAxis.valueStep = 2
    lc.lines[0].strokeWidth = 2
    lc.lines[1].strokeWidth = 1.5
    lc.lines[0].strokeColor = colors.black
    lc.lines[1].strokeColor = colors.red
    lc.lines[2].strokeColor = colors.green
    lc.lines[3].strokeColor = colors.blue
    lc.lines[4].strokeColor = colors.pink
    lc.lines[5].strokeColor = colors.chocolate
    drawing.add(lc)
    renderPM.drawToFile(drawing, os.path.join(context.localWeblog,"pdfPerMonth.gif"), 'GIF')


