import os
import os.path
from mx.DateTime import DateTime,DateTimeDelta
import string
import gzip
from GLAentry import *
from GLApickle import *
from GLAcontext import *

def readZipFile(context,filename):
    if not os.path.isfile(os.path.join(context.zippedLogfiles,filename)):
        return []
    entries = []
    f = gzip.GzipFile(os.path.join(context.zippedLogfiles,filename),"r")
    lines = f.readlines()
    f.close()
    for line in lines:
        line = line.strip()
        if line<>"":
            entries.append(entry(line.split(" ")))
    return entries
    
def readLogFile(filename):
    if not os.path.isfile(filename):
        return []
    entries = []
    f = open(filename,"r")
    lines = f.readlines()
    print lines[0:20]
    lines = [line.strip() for line in lines]
    print lines[0:20]
    start = lines.index("")
    lines=lines[start+1:]
    print start,lines[0]
    lines = [line.replace("onmousedown= ","onmousedown=") for line in lines]
    line = 0
    while line<len(lines) and len(lines[line])>2:
        entryLine = []
        while len(entryLine)< 10:
            entryLine += string.split(lines[line])
            line += 1
        if not (entryLine[7].find("HTTP")==0 or entryLine[7].find("onmousedown")==0):
            if len(entryLine)<11:
                entryLine+= string.split(lines[line])
                line +=1
            entryLine[6] = entryLine[6]+" "+entryLine[7]
            del entryLine[7]
        entries.append(entry(entryLine))
    f.close()
    return entries

def locateDate(entries,datetime):
    lower = 0
    if entries[lower].datetime>datetime:
        return -1
    upper = len(entries)-1
    if entries[upper].datetime<datetime:
        return upper
    t = (upper+lower)/2
    while lower<>t and t<>upper:
        if entries[t].datetime<datetime:
            lower = t
        else:
            upper = t
        t = (upper+lower)/2
    return t

def makeEntryFiles(context):
    files = os.listdir(context.zippedLogfiles)
    files.sort()
    beginDate = DateTime(3000)
    lastDate = DateTime(2000)
    datesChanged = []
    for file in files:
        context.log.info(file)
        try:
            fileDate = DateTime(int(file[0:4]),
                                            int(file[4:6]),int(file[6:8]))
        except:
            context.log.info(file+" illegal input filename")
            continue
        startDate = fileDate-DateTimeDelta(6)
        endDate = startDate+DateTimeDelta(7)
        beginDate = min([startDate,beginDate])
        allpresent = 1
        date = startDate
        while date<endDate:
            dateid = date.strftime("%Y%m%d")
            dayfilename = context.makeGLAfilename(date, 3, "raw")
            allpresent = allpresent and os.path.isfile(dayfilename)
            date += DateTimeDelta(1)
            lastDate = max([date,lastDate])
        if allpresent:
            context.log.info("all days present, next logfile")
            continue
        entries = readZipFile(context,file)
        context.log.info("nr entries: %d"%len(entries))
        for entry in entries[0:10]:
            print entry.str()
        indexDate = 0
        date = startDate
        while date<endDate:
            nextdate = date+DateTimeDelta(1)
            indexNextDate = locateDate(entries,nextdate)
            dayentries = entries[indexDate:indexNextDate]
            context.log.log("date: %d-%d "%(date.month,date.day)+"\tnr entries:%5d"%len(dayentries))
            datesChanged.append(date)
            pickleToFile(context.makeGLAfilename(date,3,"raw"),dayentries)
            date = nextdate
            indexDate = indexNextDate+1
    return beginDate, lastDate, datesChanged

if __name__ == '__main__':
    drive = os.path.splitdrive(os.getcwd())[0]
    root = os.path.join(drive,"/gaudi")
    context = Context(root,LogFile(os.path.join(root,"temp\\GLAmakeEntries"),
                                   toWindow=1,showInfo=2))
    makeEntryFiles(context)


