import os.path
from Timer import Timer
from mx.DateTime import DateTime,DateTimeDelta
from GLAcontext import *
from GLAdate import *
from GLAtypes import *
from HTMLgen import *
from GLApickle import *
import ipreversal
import pprint

def alldigits(ip):
    ipelements = ip.split(".")
    alldigit = 1
    for el in ipelements:
        alldigit = alldigit and el.isdigit()
    return alldigit

def searchDomain(domain,context,ipDB,startDate,endDate):
    results = []
    docs = Hist()
    ips = Hist()
    for day in dayGenerator(startDate,endDate):
        validHitsFilename = context.makeGLAfilename(day,3,"hits")
        if os.path.isfile(validHitsFilename):
            set = unPickleFile(validHitsFilename,context)
            for entry in set:
                entryDomain = translateIP(entry.domain,ipDB)
                entryDate = entry.datetime.strftime("%Y-%m-%d %H:%M")
                if entryDomain.endswith(domain):
                    results.append(entryDate+"  "+entry.file+"."+entry.ext)
                    docs.add(entry.file+"."+entry.ext)
                    ips.add(entryDomain)
    results.sort()
##    pprint.pprint(results)
    print "total: ",len(results)
    pprint.pprint(docs.getHist())
    pprint.pprint(ips.getHist())


def searchFile(file,ext,context,ipDB,startDate,endDate):
    results = []
    docs = Hist()
    ips = Hist()
    for day in dayGenerator(startDate,endDate):
        validHitsFilename = context.makeGLAfilename(day,3,"hits")
        if os.path.isfile(validHitsFilename):
            set = unPickleFile(validHitsFilename,context)
            for entry in set:
                if entry.file==file and entry.ext==ext:
                    results.append(entry.datetime.strftime("%Y-%m-%d %H:%M  ")+
                                   translateIP(entry.domain,ipDB))
    results.sort()
    pprint.pprint(results)
    print "total: ",len(results)

def searchNumipFile(file,ext,context,ipDB,startDate,endDate):
    results = []
    docs = Hist()
    ips = Hist()
    for day in dayGenerator(startDate,endDate):
        validHitsFilename = context.makeGLAfilename(day,3,"hits")
        if os.path.isfile(validHitsFilename):
            set = unPickleFile(validHitsFilename,context)
            for entry in set:
                domain = translateIP(entry.domain,ipDB)
                if entry.file==file and entry.ext==ext and alldigits(domain):
                    results.append(entry.datetime.strftime("%Y-%m-%d %H:%M  ")+
                                   domain)
    results.sort()
    pprint.pprint(results)
    print "total: ",len(results)

def main():
    t = Timer()
    drive = os.path.splitdrive(os.getcwd())[0]
    root = os.path.join(drive,"/gaudi")
    context = Context(root,LogFile(os.path.join(root,"temp/GLA"),
                                   toWindow=1,showInfo=0))
    ipDB = ipreversal.IPdb(os.path.join(context.PythonTools,"ipreverseNew.txt"))
    startDate,endDate = context.getDateRange()
    print startDate, endDate
    print t.stamp("initialized")
##    searchNumipFile("SystemArchitectureBook","pdf",context,ipDB,startDate,endDate)
##    searchNumipFile("ThesisBook","pdf",context,ipDB,startDate,endDate)
    searchFile("ThesisBook","pdf",context,ipDB,endDate-DateTimeDelta(28),endDate)
##    searchFile("ESresearchAgendaPaper","pdf",context,ipDB,startDate,endDate)
##    searchFile("RoleSystemArchitectPaper","pdf",context,ipDB,startDate,endDate)
##    searchFile("Thesis.old","html",context,ipDB,startDate,endDate)
##    searchDomain("suomi.net",context,ipDB,startDate,endDate)
##    searchDomain("google.66.249.com",context,ipDB,startDate,endDate)
    print t.stamp("finished")
    context.close()
    
if __name__ == '__main__':
    main()
