import os.path
from Timer import Timer
from mx.DateTime import DateTime,DateTimeDelta
from GLAcontext import *
from GLAdate import *
from GLAtypes import *
from HTMLgen import *
from GLApickle import *
import ipreversal
import pprint

def getSizes(context,ipDB,startDate,endDate):
    typesizes = Hist()
    for day in dayGenerator(startDate,endDate):
        validHitsFilename = context.makeGLAfilename(day,3,"hits")
        if os.path.isfile(validHitsFilename):
            set = unPickleFile(validHitsFilename,context)
            for entry in set:
                typesizes.add(entry.ext,entry.length)
    pprint.pprint(typesizes.getHist())
    print "total: ",typesizes.total

def main():
    t = Timer()
    drive = os.path.splitdrive(os.getcwd())[0]
    root = os.path.join(drive,"/gaudi")
    context = Context(root,LogFile(os.path.join(root,"temp/GLA"),
                                   toWindow=1,showInfo=0))
    ipDB = ipreversal.IPdb(os.path.join(context.PythonTools,"ipreverseNew.txt"))
    startDate, endDate = context.getDateRange()
    print t.stamp("initialized")
    getSizes(context,ipDB,startDate,endDate)
    print t.stamp("finished")
    context.close()
    
if __name__ == '__main__':
    main()
