from Tkinter import *
import math
import random

class Vector2D:
    def __init__(self,x,y):
        self.x = x
        self.y = y
    
    def rotate( self,phi):
        x = self.x*math.cos(phi)+self.y*math.sin(phi)
        y = -self.x*math.sin(phi)+self.y*math.cos(phi)
        return Vector2D(x,y)

    def add(self, op2):
        return Vector2D(self.x+op2.x,self.y+op2.y)
    def sub(self, op2):
        return Vector2D(self.x-op2.x,self.y-op2.y)
    def length(self):
        return math.sqrt(self.x**2+self.y**2)
    def normalize(self):
        length = self.length()
        return Vector2D(self.x/length,self.y/length)
    def distance(self,op2):
        return math.sqrt((self.x-op2.x)**2+(self.y-op2.y)**2)

def showPos( canvas,pos,r,color ):
    canvas.create_oval(pos.x-r,pos.y-r,pos.x+r,pos.y+r,fill=color,outline="black")
    
def main():
    root = Tk()
    print root
    canvas = Canvas(root, width=800,height=700)
    canvas.pack()
    start = Vector2D(100,650)
    for tInterval in (20,30,50):
        pos = start
        start = start.add(Vector2D(200,0))
        targetOffset = Vector2D(0.0,-400.0)
        target = pos.add(targetOffset)
        d = 0.2
        dTarget = Vector2D(random.choice((-d,+d)),random.choice((-d,+d)))
        r = 30
        canvas.create_oval(target.x-r,target.y-r,target.x+r,target.y+r,fill="red")
        t = 0
        dt = 1
        tEndInterval = 0
        print "start now pos:", pos.x, pos.y, "target:",target.x,target.y
        print "distance: ", pos.distance(target), " r:", r, " t:",t
        phi=math.pi/100
        while (pos.distance(target)>r) and (t<30*tInterval):
            phi = random.choice((phi,-phi))
            delta = target.sub(pos)
            delta = delta.normalize()
            tEndInterval +=tInterval
            showPos(canvas,pos,3,"green")
            showPos(canvas,target,r,"red")
            dTarget = dTarget.rotate((random.random()-0.5))
            while t<tEndInterval:
                delta = delta.rotate(phi)
                newpos = pos.add(delta)
                canvas.create_line(pos.x,pos.y,newpos.x,newpos.y,fill='black')
                pos = newpos
                target = target.add(dTarget)
                t+=dt
        
##    canvas.create_rectangle(100,100,200,200,outline='black',fill='white')
##    canvas.create_text(200,200,text='text')

if __name__ == '__main__':
    main()
