import string
import os
import os.path
import glob
import stat
from win32com.client.dynamic import Dispatch
import pythoncom
import shutil
import time
import pprint
import zipfile
from GLAcontext import Context
from context import LogFile
from HTMLgen import *

class Figure:
    def __init__(self, fileName, context):
        self.fileName = fileName
        self.context = context
        self.pdfFile = context.checkFile(
            os.path.join(self.context.figures,self.fileName+".pdf"))
        self.pdfMtime = 0
        if self.pdfFile !="":
            self.pdfMtime = os.stat(self.pdfFile)[stat.ST_MTIME]
        self.stampFile = os.path.join(self.context.wwwfigures,self.fileName+".stamp.gif")
        if os.path.isfile(self.stampFile):
            self.stampMtime = os.stat(self.stampFile)[stat.ST_MTIME]
        else:
            self.stampMtime = 0
        self.fullsizeFile = os.path.join(self.context.wwwfigures,self.fileName+".fullsize.gif")
        if os.path.isfile(self.fullsizeFile):
            self.fullsizeMtime = os.stat(self.fullsizeFile)[stat.ST_MTIME]
        else:
            self.fullsizeMtime = 0
        self.htmlFile = os.path.join(self.context.wwwfigures,self.fileName+".html")
        if os.path.isfile(self.htmlFile):
            self.htmlMtime = os.stat(self.htmlFile)[stat.ST_MTIME]
        else:
            self.htmlMtime = 0
        if not self.fileName in excludeFigureList:    
            self.vsdFile = context.checkFile(
                os.path.join(self.context.figureSources,self.fileName+".vsd"))
        else:
            self.vsdFile = ""
        if self.vsdFile=="":
            self.vsdMtime = 0
        else:
            self.vsdMtime = os.stat(self.vsdFile)[stat.ST_MTIME]
        self.epsFile = os.path.join(self.context.figures,self.fileName+".eps")
        
    def vsdtoeps(self):
        tempfilename="a%d"%self.context.sequence
        tempfile=os.path.join(self.context.temp,tempfilename+".vsd")
        if os.path.isfile(tempfile):
            os.remove(tempfile)
        shutil.copy(os.path.join(self.context.figureSources,self.fileName+".vsd"),tempfile)
        tryCount = 0
        while tryCount<3:
            tryCount += 1
            try:
                doc = self.context.visio.Documents.OpenEx(tempfile,8)
                doc.PrintLandscape = 0
                doc.PrintLandscape = -1
                page = doc.Pages(1)
                tempepsfile = os.path.join(self.context.figures,tempfilename+".eps")
                if os.path.isfile(tempepsfile):
                    self.context.log.log("unexpected epsfile deleted "+tempepsfile)
                    os.remove(tempepsfile)
                page.Export(tempepsfile)
                print self.fileName, " exported"
                doc.Saved = 1
                doc.Close()
                page = 0
                doc = 0
                tryCount = 5
            except pythoncom.com_error,(hr,msg,exc,arg):
                self.context.log.log("***Visio failed with code %d: %s"%(hr,msg))
                if exc is None:
                    self.context.log.log( "There is no extended information")
                else:
                    wcode, source, text, helpFile, helpId, scode = exc
                    self.context.log.log( "the source of the error is: "+ source)
                    self.context.log.log( "the error message is: "+ text)
                    self.context.log.log( "more info can be found in %s (id=%d)"%(helpFile,helpId))
                    self.context.log.info("com interfacecount: %d"%pythoncom._GetInterfaceCount())
                if tryCount>2:
                    raise RuntimeError,"Visio failed too many times"
                print "before Quit ", self.context.visio
                self.context.visio.Quit()
                time.sleep(1)
                self.context.visio = Dispatch("Visio.Application")
                print "after restart: ", self.context.visio
        os.remove(tempfile)
        if os.path.isfile(self.epsFile):
            os.remove(self.epsFile)
        os.rename(tempepsfile, self.epsFile)

    def epstopdf(self):
        os.chdir(self.context.figures)
        fd = os.popen("epstopdf "+self.fileName+".eps")
        result = fd.read()
        self.context.log.log(result)
        fd.close()
        self.pdfFile = os.path.join(self.context.figures,self.fileName+".pdf")
        if not os.path.isfile(self.pdfFile):
            self.pdfFile = ""
        else:
            self.pdfMtime = os.stat(self.pdfFile)[stat.ST_MTIME]
            
    def vsdtoGif(self,target):
        tempfilename="a%d"%self.context.sequence
        tempfile=os.path.join(self.context.temp,tempfilename+".vsd")
        if os.path.isfile(tempfile):
            os.remove(tempfile)
        shutil.copy(os.path.join(self.context.figureSources,self.fileName+".vsd"),tempfile)
        tryCount = 0
        while tryCount<3:
            tryCount += 1
            try:
                doc = self.context.visio.Documents.OpenEx(tempfile,8)
                doc.PrintLandscape = 0
                doc.PrintLandscape = -1
                page = doc.Pages(1)
                tempStampfile = os.path.join(self.context.figures,tempfilename+".gif")
                if os.path.isfile(tempStampfile):
                    self.context.log.log("unexpected stampfile deleted "+tempStampfile)
                    os.remove(tempStampfile)
                page.Export(tempStampfile)
                time.sleep(0.2)
                print self.fileName, " exported"
                doc.Saved = 1
                time.sleep(0.2)
                doc.Close()
                time.sleep(0.2)
                page = 0
                doc = 0
                tryCount = 5
            except pythoncom.com_error,(hr,msg,exc,arg):
                self.context.log.log("***Visio failed with code %d: %s"%(hr,msg))
                if exc is None:
                    self.context.log.log( "There is no extended information")
                else:
                    wcode, source, text, helpFile, helpId, scode = exc
                    self.context.log.log( "the source of the error is: "+ source)
                    self.context.log.log( "the error message is: "+ text)
                    self.context.log.log( "more info can be found in %s (id=%d)"%(helpFile,helpId))
                    self.context.log.info("com interfacecount: %d"%pythoncom._GetInterfaceCount())
                if tryCount>4:
                    raise RuntimeError,"Visio failed too many times"
                print "before Quit ", self.context.visio
                self.context.visio.Quit()
                time.sleep(1)
                self.context.visio = Dispatch("Visio.Application")
                print "after restart: ", self.context.visio
        os.remove(tempfile)
        if os.path.isfile(target):
            os.remove(target)
        os.rename(tempStampfile, target)
        
    def generateHtmlFile(self,docs):
        fdoc = SimpleDocument(title="Figure info "+self.fileName,bgcolor="#DEDEDE")
        fdoc.append(Image(self.fileName+".fullsize.gif"),BR(),"\n")
        fdoc.append(Header(3,self.fileName),"\n")
        for d in docs:
            type,title = self.context.fileToTitle(d,".pdf")
            fdoc.append(Text(type+":\t"),Href("../"+d+".pdf",title),BR(),"\n")
        fdoc.write(self.htmlFile)
                
    def generate(self): 
        self.context.log.info( "generate "+ self.fileName)
        self.vsdtoeps()
        self.epstopdf()
        os.remove(self.epsFile)

def generateHtml(context,figures,crossRef):
    for figure in figures:
        aFigure = Figure(figure,context)
        if aFigure.vsdMtime>aFigure.htmlMtime:
            aFigure.generateHtmlFile(crossRef.setdefault(figure,[]))
        
def generateStamps(context):
    if not os.path.isfile("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.original.ini"):
        os.rename("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI",
                  "C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.original.ini")
    shutil.copy(os.path.join(context.PythonTools,"Ebgif2.INI.stamp"),
                "C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI")
    os.chdir(context.figureSources)
    sourceFigures = glob.glob("*.vsd")
    sourceFigures.sort()
    for sourceFigure in sourceFigures:
        context.sequence += 1
        figure = Figure(sourceFigure[:-4],context)
        if figure.vsdMtime>figure.stampMtime:
            figure.vsdtoGif(figure.stampFile)
    os.remove("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI")
    os.rename("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.original.ini",
              "C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI")

def generateFullsize(context):
    if not os.path.isfile("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.original.ini"):
        os.rename("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI",
                  "C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.original.ini")
    shutil.copy(os.path.join(context.PythonTools,"Ebgif2.INI.fullsize"),
                "C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI")
    os.chdir(context.figureSources)
    sourceFigures = glob.glob("*.vsd")
    sourceFigures.sort()
    for sourceFigure in sourceFigures:
        context.sequence += 1
        figure = Figure(sourceFigure[:-4],context)
        if figure.vsdMtime>figure.fullsizeMtime:
            figure.vsdtoGif(figure.fullsizeFile)
    os.remove("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI")
    os.rename("C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.original.ini",
              "C:\\Program Files\\Visio\\System\\Filter32\\Ebgif2.INI")

def generatePdf(context):
    if not os.path.isfile("C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.original.ini"):
        os.rename("C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.INI",
                  "C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.original.ini")
    shutil.copy(os.path.join(context.PythonTools,"Emps_2.INI"),
                "C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.INI")
    os.chdir(context.figureSources)
    sourceFigures = glob.glob("*.vsd")
    sourceFigures.sort()
    for sourceFigure in sourceFigures:
        context.sequence += 1
        figure = Figure(sourceFigure[:-4],context)
        if figure.vsdMtime>figure.pdfMtime:
            figure.generate()
    os.remove("C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.INI")
    os.rename("C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.original.ini",
              "C:\\Program Files\\Visio\\System\\Filter32\\Emps_2.INI")

excludeFigureList = ["EmbleemPlusName","logoTBD",]

def compareCaseInsensitive(a,b):
    return cmp(a.lower(),b.lower())

def makeCrossRef(context):
## timestamp last modification per figure to be added
    os.chdir(context.figCrossRef)
    docs = glob.glob("*.txt")
    crossRef = {}
    for doc in docs:
        docFile = open(doc)
        figures=docFile.readlines()
        for figure in figures:
            crossRef.setdefault(figure[:-1],[])
            crossRef[figure[:-1]].append(doc[:-4])
    return crossRef

def splitName( name, length ):
    if len(name)<=length:
        return [name]
    index = length
    letters = list(name[:length])
    letters.reverse()
    for letter in letters:
        if letter.isupper():
            break
        index -= 1
    if index<2:
        index = length
    result = [name[:index-1]]
    result+=splitName(name[index-1:],length)
    return result

def generateNavBar(currentPage,nrPages):
    navBar = TR(TH(Href("index.html","Gaud&iacute main")))
    for pageNr in range(1,nrPages+1):
        if pageNr<>currentPage:
            navBar.append(TD(Href("stamps%02d.html"%pageNr,"%d"%pageNr)),"\n")
        else:
            navBar.append(TD(Bold("%d"%pageNr)),"\n")
    if currentPage>1:
        navBar.append(TD(Href("stamps%02d.html"%(currentPage-1),"previous")),"\n")
    if currentPage<nrPages:
        navBar.append(TD(Href("stamps%02d.html"%(currentPage+1),"next")),"\n")
    return TableLite(navBar)

def removeOldFigures(context):
    os.chdir(context.figureSources)
    vsdFiles = glob.glob("*.vsd")
    vsdRoots = [vsdFile[:-4] for vsdFile in vsdFiles]
    os.chdir(context.wwwfigures)
    stampFiles = glob.glob("*.stamp.gif")
    fullsizeFiles = glob.glob("*.fullsize.gif")
    infoFiles = glob.glob("*.html")
    for stampFile in stampFiles:
        root = stampFile[:-10]
        if not root in vsdRoots:
            os.remove(stampFile)
            context.log.log("removed "+stampFile)
    for fullsizeFile in fullsizeFiles:
        root = fullsizeFile[:-13]
        if not root in vsdRoots:
            os.remove(fullsizeFile)
            context.log.log("removed "+fullsizeFile)
    for infoFile in infoFiles:
        root = infoFile[:-5]
        if not root in vsdRoots:
            os.remove(infoFile)
            context.log.log("removed "+infoFile)

def generateStampRow( stamps, color ):
    rowImages = TR(bgcolor = color)
    rowText = TR(bgcolor = color)
    for stamp in stamps:
        rowImages.append(TD(Href("figures/"+stamp+".html",
                          Image("figures/"+stamp+".stamp.gif",border=0))),"\n")
        parts = splitName(stamp,20)
        text = Text()
        for part in parts:
            text.append(Small(part))
            text.append(BR())
        rowText.append(TD(Href("figures/"+stamp+".html",text)),"\n")
    return Container(rowImages,rowText)

def generateStampMatrix(stamps,nrColumns):
    bgcolors = ["#FFE0E0","lightyellow"]
    tab = TableLite()
    color = 0
    for first in range(0,len(stamps),nrColumns):
        tab.append(generateStampRow(stamps[first:first+nrColumns],bgcolors[color]))
        color = 1 - color
    return tab

def main():
    drive = os.path.splitdrive(os.getcwd())[0]
    rootdir = os.path.join(drive,"\\gaudi")
    logFile = LogFile(os.path.join(rootdir,"temp","generateGifs"),toWindow=1,showInfo=0)
    context = Context(rootdir,logFile)
    removeOldFigures(context)
    if context.visio==0:
        context.visio = Dispatch("Visio.Application")
    startTime = time.time()
    logFile.log( "started at: "+ time.ctime(startTime))
    generatePdf(context)
    generateStamps(context)
    generateFullsize(context)
    crossRef = makeCrossRef(context)
    nrColumns = 6
    nrRows = 5
    os.chdir(context.wwwfigures)
    figures = glob.glob("*.stamp.gif")
    figures = [figure[:-10] for figure in figures]
    nrPages = (len(figures)+(nrColumns*nrRows)-1)/(nrColumns*nrRows)
    figures.sort(compareCaseInsensitive)
    pageNr = 1
    for index in range(0,len(figures),nrColumns*nrRows):
        doc = SimpleDocument(title="Pictorial index")
        doc.append(generateNavBar(pageNr,nrPages))
        doc.append(generateStampMatrix(figures[index:index+nrColumns*nrRows],nrColumns))
        doc.append(generateNavBar(pageNr,nrPages))
        doc.write(os.path.join(context.www,"stamps%02d.html"%pageNr))
        pageNr += 1
    generateHtml(context, figures, crossRef)
    unrefferedFigures=[]
    for figure,docList in crossRef.items():
        if len(docList)<1:
            unrefferedFigures.append(figure)
    unusedOutput = open(os.path.join(context.local,"UnrefferedFigures.txt"),"w")
    unrefferedFigures.sort(compareCaseInsensitive)
    unusedOutput.write("possibly %d unused figures:\n"%len(unrefferedFigures))
    for figure in unrefferedFigures:
        unusedOutput.write(figure+"\n")
    unusedOutput.close()
    print "possibly %d unused figures:"%len(unrefferedFigures)

    endTime = time.time()
    logFile.log("finished at: "+ time.ctime(endTime))
    logFile.log("total elapsed time:%7.1f seconds"%(endTime - startTime))
    logFile.close()

    
if __name__ == '__main__':
    main()
    
